unit frmHOProInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ORCtrls, ExtCtrls, Menus, VA508AccessibilityManager;
type
  TProvInfo = record
  Name     : String;
  UserType : String;
  Mod_Pat  : integer;
  Mod_Prov : integer;
  Pager    : String;
  Phone    : String;
  end;
type
  TfrmPrvInfo = class(TForm)
    Panel1: TPanel;
    cboHOProvider: TORComboBox;
    Panel2: TPanel;
    btnOk: TButton;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    btnExit: TButton;
    procedure btnSaveClick(Sender: TObject);
    procedure cboHOProviderDblClick(Sender: TObject);
    procedure cboHOProviderNeedData(Sender: TObject;
      const StartFrom: String; Direction, InsertAt: Integer);
    procedure FormShow(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
  private
    { Private declarations }
     
  public
    { Public declarations }
     User200 : String;
     TM : String;
  end;

var
  frmPrvInfo: TfrmPrvInfo;


Function ProviderSelection(TeamN,Txt: String): String;

implementation

{$R *.DFM}
uses OrNet, Orfn, rcore, frmHOListSetup, Util;

//ProviderInfo==================================
Function ProviderSelection(TeamN, Txt: String): String;
var
frmPrvAddInfo : TfrmPrvInfo;
begin
  frmPrvAddInfo := TfrmPrvInfo.Create(Application);
  try
   with frmPrvAddInfo do
     begin
      if Txt <> '' then
        begin
          TM := TeamN;

       with cboHOProvider do
        begin
        ListItemsOnly := true;
        LongList := true;
        InitLongList(Txt);
        end;
        cboHOProvider.Text := Txt;
        cboHOProvider.ItemIndex := 0;
        end;
    ShowModal;
    Result := User200;
    end;
  finally
    frmPrvAddInfo.Free;
  end;

end;

procedure TfrmPrvInfo.btnSaveClick(Sender: TObject);
begin
fHOListSetup.Close;
end;

procedure TfrmPrvInfo.cboHOProviderDblClick(Sender: TObject);
begin
  btnOkClick(btnOk);
end;

procedure TfrmPrvInfo.cboHOProviderNeedData(Sender: TObject;
  const StartFrom: String; Direction, InsertAt: Integer);
begin
cboHOProvider.ForDataUse(SubSetOfPersons(StartFrom, Direction));
end;

procedure TfrmPrvInfo.FormShow(Sender: TObject);
begin
cboHOProvider.SetFocus;
end;

procedure TfrmPrvInfo.btnExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmPrvInfo.btnOkClick(Sender: TObject);
begin
if cboHOProvider.ItemIndex > -1 then
User200 := cboHOProvider.Items[cboHOProvider.ItemIndex];
Close;
end;

end.
